//############################################################################
//
// Tetris C  Version 1.01
//
// by David Coz
//
// coz.hubert@infonie.fr
//
// Created 01/12/2001; 13:40:44
//
//############################################################################

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#define ABS(a)  (((a)<0) ? -(a): (a))


static unsigned char piece[15][8]={
{0xFE,0x82,0xBA,0xBA,0xFE,0x00,0x00,0x00},
{0xFE,0xFE,0xC6,0xFE,0xFE,0x00,0x00,0x00},
{0xFE,0xEE,0xEE,0xEE,0xFE,0x00,0x00,0x00},
{0xFE,0x82,0x8A,0xBA,0xFE,0x00,0x00,0x00},
{0xFE,0x82,0x92,0x82,0xFE,0x00,0x00,0x00},
{0xFE,0xC6,0xC6,0xC6,0xFE,0x00,0x00,0x00},
{0xFE,0x90,0x84,0xA0,0xFE,0x00,0x00,0x00},
{0xFE,0x90,0x04,0x20,0xFE,0x00,0x00,0x00},
{0xFE,0x88,0x00,0x50,0xFE,0x00,0x00,0x00},
{0xFE,0x0A,0x82,0x22,0xFE,0x00,0x00,0x00},
{0xFE,0x82,0xA6,0x82,0xC2,0x00,0x00,0x00},
{0x8A,0xA2,0x82,0xC2,0x8A,0x00,0x00,0x00},
{0x82,0xA2,0x8A,0x82,0x92,0x00,0x00,0x00},
{0xC6,0x82,0x8A,0xA2,0xFE,0x00,0x00,0x00},
{0xFE,0x82,0x82,0x82,0xFE,0x00,0x00,0x00},
};


char his[1];
char mat[22][13];

unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}


void des(unsigned short *pt,unsigned short x,unsigned short y)
{
unsigned	char i,j;
	for(i=0;i<4;i++)
	for(j=0;j<4;j++)
	{
	if (pt[i*4+j]!=0)
	Sprite8(3+x*7+j*7,y*5+i*5,8,piece[pt[i*4+j]-1],LCD_MEM,SPRT_XOR);
	//mat[y+i][x+j]=mode;
	}
}

void te(unsigned short *pt,unsigned short x,unsigned short y,int mode)
{
	unsigned	char i,j;
	for(i=0;i<4;i++)
	for(j=0;j<4;j++)
	{
	if (pt[i*4+j]!=0)
		mat[y+i][x+j]=mode;
}
}

void tte()
{
	int i,j;
	FontSetSys(F_4x6);
	for (i=0;i<20;i++)
	for (j=0;j<13;j++)
	printf_xy(j*7+3,i*5,"%d",mat[i][j]);
	ngetchx();
}

INT_HANDLER oldint5 = NULL;

volatile int mseconds50 = 0; 
volatile int seconds    = 0; 
volatile int minutes    = 0; 
volatile int resettime  = 1; 
volatile int running  =0;
int mode;


DEFINE_INT_HANDLER (myint5handler) {
    //----------------------------------------------
    // if resettime is not 0 all clock variables are
    // reset to 0
    //----------------------------------------------
  
    if (resettime) {
        mseconds50=seconds=minutes=resettime=0;
    }
    else if (running==1){
    
        mseconds50++;
        if (mseconds50 == 19) {
            mseconds50 = 0;
            seconds++;
            if (seconds == 60) {
                seconds = 0;
                minutes++;
              }
        }
  
  
    }
    ExecuteHandler(oldint5);
}

typedef struct
  {
    char name[10];
    unsigned long score;
  } HSC_ITEM;

typedef struct
  {
    char name[10];
unsigned short min;
  unsigned short sec;
  } BT_ITEM;

  void input_str(char *str)
{
  int i=0,key=0;
  DrawStr(10,10,"CONGRATULATIONS!",A_NORMAL);
  FontSetSys(F_6x8);
  DrawStr(10,30,"You Entered The TOP!",A_NORMAL);
  DrawStr(10,50,"Enter Your Name:",A_NORMAL);
  
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
      DrawStr(30,60,str,A_REPLACE);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<8) str[i++]=key;
      if(key==257&&i)
      {
      	//str[i]=' ';
      	i--;
      }
}
str[i]=0;
}

void best(HSC_ITEM bestscore[],unsigned long score)
{
  int i;
  for(i=2;(bestscore[i-1].score<score)&&i;i--)
    memcpy(&bestscore[i],&bestscore[i-1],sizeof(HSC_ITEM));
  bestscore[i].score=score;
  ClrScr();
  FontSetSys(F_8x10);
  input_str(bestscore[i].name);
 }

void best2(BT_ITEM bestscore[],unsigned short min,unsigned short sec)
{
  int i;
  for(i=2;(60*bestscore[i-1].min+bestscore[i-1].sec>60*min+sec)&&i;i--)
    memcpy(&bestscore[i],&bestscore[i-1],sizeof(BT_ITEM));
  bestscore[i].min=min;
  bestscore[i].sec=sec;
  ClrScr();
  FontSetSys(F_8x10);
  input_str(bestscore[i].name);
 }


  void  redes(int y)
{
 int i,j;
 for (i=0;i<5;i++)
 {
 	DrawLine(10,y*5+i,86,y*5+i,A_REVERSE);
 }
 for (i=y;i>0;i--)
for (j=1;j<12;j++)
mat[i][j]=mat[i-1][j];

for (j=1;j<12;j++)
mat[0][j]=0;
 	
 y*=5;
SCR_RECT zone_clip = {{0, 0, 160, 100}}; 
SCR_RECT a_sauver1 = {{10,0, 86, y-1}};
char buffer2[BITMAP_HDR_SIZE + 100*80/8];
         BitmapGet(&a_sauver1, buffer2);
         BitmapPut(10, 0, buffer2,&zone_clip,A_XOR);
         BitmapPut(10, 5, buffer2,&zone_clip,A_XOR);
	}

 void redes2(void)
 {
 	int i,a,b,c,d;
SCR_RECT zone_clip = {{0, 0, 160, 100}}; 
SCR_RECT a_sauver1 = {{10,5, 86,94}};
 	char buffer2[BITMAP_HDR_SIZE + 100*80/8];
  BitmapGet(&a_sauver1, buffer2);
  BitmapPut(10, 5, buffer2,&zone_clip,A_XOR);
  BitmapPut(10, 0, buffer2,&zone_clip,A_XOR);
 randomize();
 a=random(11);
 b=random(11);
 c=random(11);
 d=random(11);
  for (i=0;i<11;i++)
 {
 	if (i!=a&&i!=b&&i!=c&&i!=d)
 	Sprite8(10+i*7,90,8,piece[random(15)],LCD_MEM,SPRT_XOR);
 }
 
  } 
  
  
void lignea(int y,int *ligne)
{
	
	int i,j,k;
	for (j=0;j<4;j++)
	{
			k=0;
			for (i=1;i<12;i++)
			{
					if (y*5+5*j>=95)
					return;
					if (mat[y+j][i])//(10+i*7,y+j*5))
					k=k+1;
			}
 			if (k==11)
 			{
 				*ligne=*ligne+1;
 					redes(y+j);
			    
			   
				}
		
			}
		
	}

//void wait(unsigned short int w)
//{
  // OSFreeTimer(USER_TIMER);
 //  OSRegisterTimer(USER_TIMER,w);
 //  while(!OSTimerExpired(USER_TIMER));
//}

int test(int x,int y,int xx,int yy, unsigned short *tab)
{
//tte();
int i,j;
for (i=0;i<4;i++)
{
	for (j=0;j<4;j++)
  if (tab[i+4*j]!=0)
   {
  	if (mat[y+yy+j][x+xx+i])
  	return 1;	
  } 
}
return 0;
} 

void _main(void)
{



static HSC_ITEM bestscore[3]={{"David",10000},{"David",3000},
    {"David",0}};
static BT_ITEM besttime[3]={{"David",3,31},{"David",3,48},
    {"David",3,49}};
ClrScr();
unsigned i;
int niv=0,key=0,mode=0;
	FontSetSys(F_8x10);
	DrawStr(55,20,"TETRIS",A_NORMAL); 
 for (i=0;i<4;i++) 
 {
 	DrawLine(0,i,159,i,A_NORMAL);
 	DrawLine(0,99-i,159,99-i,A_NORMAL);
 	DrawLine(i,0,i,100,A_NORMAL);
 	DrawLine(159-i,0,159-i,100,A_NORMAL);
 	
 }
 for (i=0;i<3;i++)
 {
 DrawLine(12+i,12+i,12+i,36-i,A_NORMAL);
 DrawLine(146-i,12+i,146-i,36-i,A_NORMAL);
 }
 DrawLine(15,13,143,13,A_NORMAL);
 DrawLine(14,35,144,35,A_NORMAL);
 DrawLine(13,36,145,36,A_NORMAL);
 	FontSetSys(F_4x6); 
 	DrawStr(45,90,"2001 by David COZ",A_NORMAL);
 for (i=0;i<3;i++)
{
printf_xy(10,50+6*i,"%d.",i+1); 	
 	DrawStr(18,50+6*i,bestscore[i].name,A_NORMAL);
printf_xy(50,50+6*i,"%ld",bestscore[i].score); 	
printf_xy(85,50+6*i,"%d.",i+1); 	
 	DrawStr(93,50+6*i,besttime[i].name,A_NORMAL);
printf_xy(128,50+6*i,"%02d:%02d",besttime[i].min,besttime[i].sec); 	


}

 

while (key!=999)
{
FontSetSys(F_6x8);
if (mode>9)
printf_xy(29,76,"[1]Level :%d",niv);
if (mode<9)
{
 		DrawStr(8,75,"NORMAL",mode==0 ? A_REVERSE :A_REPLACE  );
 	DrawStr(47,75,"50 LINES",mode==1 ? A_REVERSE :A_REPLACE  );
 	DrawStr(100,75,"FAST",mode==2 ? A_REVERSE :A_REPLACE  );
 }	
 	key=ngetchx();
 if (key==13&&mode>9)
key=999;

	if (key==13&&mode<9)
{
for (i=74;i<86;i++)
DrawLine(7,i,155,i,A_REVERSE);

	mode+=10;
}

	if (key==264)
		return;

	if (key==338&&mode!=0)
	mode--;
if (key==344&&mode!=2)
	mode++;
		
		if (key==49&&mode>9)
	{
		if (niv<9)
		niv++;
		else
		niv=0;
		}
} 	














 ClrScr();
 mode-=10;
	FontSetSys(F_6x8); 
DrawLine(87,0,87,99,A_NORMAL);
DrawLine(94,0,94,99,A_NORMAL);
DrawLine(94,0,159,0,A_NORMAL);
DrawLine(94,25,159,25,A_NORMAL);
DrawLine(94,41,159,41,A_NORMAL);
DrawLine(94,57,159,57,A_NORMAL);

DrawLine(94,99,160,99,A_NORMAL);
DrawLine(159,0,159,99,A_NORMAL);

for (i=95;i<100;i++)
{
DrawLine(3,i,94,i,A_NORMAL);
}
DrawLine(9,0,9,100,A_NORMAL);
for (i=0;i<4;i++)
{
DrawLine(i,0,i,100,A_NORMAL);
DrawLine(i+94,0,i+94,100,A_NORMAL);
}
for (i=0;i<95;i+=5)
{
	DrawLine(3,i,9,i,A_NORMAL);
DrawLine(87,i,94,i,A_NORMAL);

}
DrawStr(110,3,mode==1 ? "Time" : "Score",A_NORMAL);
DrawStr(99,30,"Lines 0",A_NORMAL);
DrawStr(110,62,"Next",A_NORMAL);
//OSFreeTimer(USER_TIMER);
   
// INT_HANDLER save_int_1;
//save_int_1 = GetIntVec(AUTO_INT_1);
//SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
//OSSetSR(0x0400);   

 
    oldint5 = GetIntVec(AUTO_INT_5);
    SetIntVec(AUTO_INT_5, myint5handler);
   resettime = 1;   


/*
INT_HANDLER save_int_1;
save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER); 
*/

unsigned long int score=0,hw=GetHardwareVersion ();
int p,sp,mm,m,pp,k,kk=(mode==2 ?0:hw==2 ?59:48),k1=(hw==2 ?59:48),x=59,
old_x,y,ligne=0,l1,l2=0,cx,cy,val,u,v,g,h=0,q;
unsigned int ii;
sp=22-niv*2;
if (mode!=2)
{
//	OSFreeTimer(USER_TIMER);
//OSRegisterTimer(USER_TIMER,sp);
}

printf_xy(115,13,"%li",score);
	printf_xy(99,46,"Level %d",niv);



if (mode==1)
{
running=1;
}


his[0]=0;

for (i=0;i<20;i++)
for (u=0;u<13;u++)
mat[i][u]=0;

for (i=0;i<20;i++)
{
mat[i][0]=1;
mat[i][12]=1;
}

for (i=0;i<13;i++)
{
mat[19][i]=1;
mat[20][i]=1;
mat[21][i]=1;
}
//tte();

static unsigned short int  tableau[28][16]={{1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0},
{1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0},{1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0},
{1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0},
{2,0,0,0,2,0,0,0,2,2,0,0,0,0,0,0},{0,0,3,0,3,3,3,0,0,0,0,0,0,0,0,0},
{2,2,0,0,0,2,0,0,0,2,0,0,0,0,0,0},{3,3,3,0,3,0,0,0,0,0,0,0,0,0,0,0},

{4,0,0,0,4,4,0,0,4,0,0,0,0,0,0,0},{0,4,0,0,4,4,4,0,0,0,0,0,0,0,0,0},
{0,4,0,0,4,4,0,0,0,4,0,0,0,0,0,0},{4,4,4,0,0,4,0,0,0,0,0,0,0,0,0,0},

{5,0,0,0,5,5,0,0,0,5,0,0,0,0,0,0},{0,5,5,0,5,5,0,0,0,0,0,0,0,0,0,0},
{5,0,0,0,5,5,0,0,0,5,0,0,0,0,0,0},{0,5,5,0,5,5,0,0,0,0,0,0,0,0,0,0},

{0,6,0,0,6,6,0,0,6,0,0,0,0,0,0,0},{6,6,0,0,0,6,6,0,0,0,0,0,0,0,0,0},
{0,6,0,0,6,6,0,0,6,0,0,0,0,0,0,0},{6,6,0,0,0,6,6,0,0,0,0,0,0,0,0,0},

{0,0,0,0,0,0,0,0,7,8,9,10,0,0,0,0},{0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0},
{0,0,0,0,0,0,0,0,7,8,9,10,0,0,0,0},{0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0},

{0,15,0,0,0,15,0,0,15,15,0,0,0,0,0,0},{15,15,15,0,0,0,15,0,0,0,0,0,0,0,0,0}, 
{15,15,0,0,15,0,0,0,15,0,0,0,0,0,0,0},{15,0,0,0,15,15,15,0,0,0,0,0,0,0,0,0}}; 
randomize();
m=random(7);

a:
randomize();
mm=random(7);

p=0;
old_x=6;
x=6;
y=1;



//	unsigned long *point=piece[m*4+p];
unsigned short *pt=tableau[m*4+p];
unsigned short *pt2=tableau[mm*4+p];

des(pt2,17,15);
//Sprite32(115,76,29,point2,LCD_MEM, SPRT_XOR);

c:
if ((test(x,y,0,1,pt)==1)||(mode==1&&ligne>49)||(mode==2&&his[0]==49))
{
running=0;
if (mode==1)
	printf_xy(115, 13, "%02d:%02d",minutes,seconds);
if (test(x,y,0,1,pt)==1)

if (mode==2)

OSFreeTimer(USER_TIMER);
	DrawStr(30,40,"GAME OVER",A_REPLACE);
//	SetIntVec (AUTO_INT_1, save_int_1);
SetIntVec(AUTO_INT_5, oldint5);

	if ((score>bestscore[2].score)&&mode!=1) best(bestscore,score);
	if (((60*minutes+seconds)<(60*besttime[2].min+besttime[2].sec))&&mode==1&&ligne>49) 
		best2(besttime,minutes,seconds);

	
	while(ngetchx()!=13);
		
		return;
}

des(pt,x,y);
//DrawStr(10,2,"AAAAAAA",A_NORMAL);
//ngetchx();
//Sprite32(45, y, 28, point,LCD_MEM, SPRT_XOR);
while (!(_rowread(0x3F)&0x01)||(mode==2&&his[0]==49))
{
	while(!(_rowread(0x3F)&0x01))//OSTimerExpired(USER_TIMER))
	{
if (mode==1)
	printf_xy(115, 13, "%02d:%02d",minutes,seconds);
	key=0;
int st=0,end=12,step=1,choix=0,min=999;
/*if (random(2)==1)
{st=12;end=0;step=-1;}			
*/			
		//	des(pt,110,10);
			
			cx=0;
			for (i=st;i!=end;i+=step)
			{	
			 //if (i==0&&m!=5) continue;
		//	if (test(cx,cy,0,0,pt)) continue;
				
				for (q=0;q<4;q++)
				{
					cy=1;
					
				pt=tableau[m*4+q];
				if (test(cx,cy,0,0,pt)) continue;
				
					while(test(cx,cy,0,1,pt)==0)
					{
				//	printf_xy(110,70,"%d:%d",cy,q);
					cy++;
					}	
	
					//printf_xy(110,30,"%d:%d:%d:%d",i,q,cy,cx);
					
			  val=0;
									for (u=0;u<4;u++)
												for (v=0;v<4;v++)
						  						{
						  							//printf_xy(110,60,"%d:%d    ",u,v);
						   							//				ngetchx();
						  								if (pt[u*4+v]!=0&&(u==3 ? 1 : pt[(u+1)*4+v]==0))
						   										{
						   										h=0;
						   										//printf_xy(110,60,"%d:%d:tt",u,v);
						   										//	ngetchx();
										                
						  														while	(!mat[cy+u+1+h][cx+v])
						  			  									{ 
						  			  									val+=4;
						  			   									h++;
						  			  									 }
						  									    // printf_xy(100+h,60,"%d: ",h);
						   										//	ngetchx();
											
						  											} 
													}
					
					te(pt,cx,cy,1);	
										
										for (u=0;u<4;u++)
										{
											k=0;
										for (v=0;v<12;v++)
										{
												if (u*5+cy*5>=95)
												continue;
												if (mat[cy+u][1+v])//GetPix(10+v*7,cy+u*5)) 
												k=k+1;
											/*	if (v*7+10>=cx&&v*7+10<cx+28)
												{
												if (pt[((15+u-cy)/5)*4+(v*7+10-cx)/7]==1) k=k+1;
												}
										*/
										}
							 			if (k==12)
							 						{		val-=4+mode*4;				
													//	printf_xy(100,10,"%d:%d:%d       ",cx,q,cs[4*i+q]);
													//	ngetchx();
														}
													}
										//ngetchx();
										
											for (u=0;u<10;u++)
											{
												k=0;
												while (!mat[k][1+u])//!GetPix(10+u*7,k*5))
												k++;
												
												v=0;
												while (!mat[v][2+u])//!GetPix(17+u*7,v*5))
												v++;
												
												h=k-v;
												val+=ABS(h);
												
											}
												te(pt,cx,cy,0);
											
											
												//printf_xy(110,80,"%d:%d:%d",cs[4*i+q],i,q);
													//	ngetchx();		
				          if (val<min) 
				          {
				            choix=4*i+q;
				            min=val;
				          }
				
				
				}
				cx++;
			}
				pt=tableau[m*4];
			des(pt,x,y);
			//ngetchx();
			
			
		
		/*	if (random(2)==1)
			{
			u=0;
			while(1)
			{h=0;
			for (i=0;i<47;i++)
			{
				if (cs[co[i]]>cs[co[i+1]])
				{
					q=co[i];
					co[i]=co[i+1];
					co[i+1]=q;
					h=1;
				}
			}
			if (h==0) break;
			}
			}
			else
			while(1)
			{
			u=47;
			h=0;
			for (i=47;i>0;i--)
			{
				if (cs[co[i]]>cs[co[i-1]])
				{
					q=co[i];
					co[i]=co[i-1];
					co[i-1]=q;
					h=1;
				}
			}
			if (h==0) break;
			}
			*/
			//printf_xy(100,70,"%d:%d       ",cs[co[u]],co[u]);
			//ngetchx();	
			cx=(choix/4);
			
			key=6;
			x=6;
			
			while (p!=choix%4)
		{
		p++;
		pt=tableau[m*4+p];
		des(pt,x,y);
		for (ii=1;ii<kk*1000;ii++)
	          {
	            	
	        }
		des(pt,x,y);
		}	
			
				pt=tableau[m*4+choix%4];
			
			
			while(x!=cx)
			{
		
			if (x>cx)
			x--;
			if (x<cx)
			x++;
			 		
			 des(pt,x,y);			
		for(ii=0;ii<kk*1000;ii++)
		  {
			  	
		 }
					for(ii=0;ii<kk*1000;ii++)
	{
			  	
	}
	des(pt,x,y);
					}
					
		
		p=0;
	
	//ngetchx();
		
			cy=y;
			x=cx;
			
				while((test(x,y,0,1,pt)==0))
					{
									y++;
									}	
				//	printf_xy(130,80,"%d",y);
			//ngetchx();	
			des(pt,x,y);
			
		//	printf_xy(100,60,"%d:%d:%d:%d",co[0],x,co[0]%4,y);
		//	ngetchx();	
				//pt=tableau[m*4];
			//	des(pt,110,10);
				//	pt=tableau[m*4+co[0]%4];
		
			
			
			
			
				if (key==6)
    	{	
    	score++;
    	    	for(i=0;i<k*600;i++)
			  {
			  }
			break;
    		}

		if (key!=0)
	des(pt,old_x,y);
		//Sprite32(old_x, y, 28, point,LCD_MEM, SPRT_XOR);
		 
		 		
	if (key==3)
	{
		while(test(x,y,0,1,pt)==0)
		{score++;
		y+=5;
		}
	}
	
				
		if (key==338 && test(x,y,-1,0,pt)==0)
		x=x-7; 
		if (key==344 && test(x,y,1,0,pt)==0)  
		x=x+7;
		
		if (key!=0)
		{
		des(pt,old_x,y);

	//	Sprite32(old_x, y, 28, point,LCD_MEM, SPRT_XOR);
			
		for(i=0;i<k*1000;i++)
		  {
			  	
		 }
					for(i=0;i<k*1000;i++)
	{
			  	
	}
	 		  if (key==3)
			break;
		}
			if (old_x!=x) 
			{
			des(pt,old_x,y);
			des(pt,x,y);
			//Sprite32(old_x, y, 28, point,LCD_MEM, SPRT_XOR);
		//	Sprite32(x, y, 28, point,LCD_MEM, SPRT_XOR);
			old_x=x;
			}
		  
  if(key==2)
			{
			pp=p;
			pp=pp+1;
			des(pt,x,y);
			if (pp==4)
				pp=0;
			pt=tableau[m*4+pp];
      

		//	Sprite32(x, y, 28, point,LCD_MEM, SPRT_XOR);
	
		//	point=piece[m*4+pp];
			if (test(x,y,0,0,pt)==1)				
			{
				pp=p;
				pt=tableau[m*4+p];
      //  point=piece[m*4+p]; 
			}
					p=pp;	
		des(pt,x,y);
		//	Sprite32(x, y, 28, point,LCD_MEM, SPRT_XOR);
			  for (i=1;i<k*1000;i++)
	          {
	            	
	        }
	     }
	     }
	     des(pt,x,y);
	   //  Sprite32(x, y, 28, point,LCD_MEM, SPRT_XOR);
	     	if (test(x,y,0,1,pt)==0)
	{	
		y=y++;	
		}
	else
		{
		te(pt,x,y,1);
		des(pt,x,y);
	//	Sprite32(x, y, 28, point,LCD_MEM, SPRT_XOR);
	
	l1=ligne;
	lignea(y,&ligne);

	//printf_xy(135,70,"%d:%d",his[0],l2);
	
	
	
	 printf_xy(99,30,"Lines %d",ligne);
		if (ligne-l1==1)
	score+=40*(niv+1);
	if (ligne-l1==2)
	score+=100*(niv+1);
	if (ligne-l1==3)
	score+=300*(niv+1);
	if (ligne-l1==4)
	score+=1200*(niv+1);
	if (mode!=1)
		 printf_xy(115,13,"%li",score);	
			if (ligne>49&&mode==1)
			goto c;
		if (ligne>=niv*10+10&&mode!=2)
			{
						niv++;
		sp-=2;
			if (niv>8)
       sp++;
       if (sp==0) sp=1;
     				printf_xy(99,46,"Level %d",niv);
				OSFreeTimer(USER_TIMER);
				 OSRegisterTimer(USER_TIMER,sp);
			}
			des(pt2,17,15);
		//	Sprite32(115,76,29,point2,LCD_MEM, SPRT_XOR);
m=mm;
			goto a;
		}
des(pt,x,y);
//	Sprite32(x, y, 28, point,LCD_MEM, SPRT_XOR);
}



SetIntVec(AUTO_INT_5, oldint5);
DrawStr(50,5,"fin",A_NORMAL);

GKeyFlush();
//SetIntVec (AUTO_INT_1, save_int_1);

}

